--local iconv= require("ffi_iconv" )("utf-8", "gbk" ) 
local env_= { t= 0, tick= 0, items= {}, polygon= {}, 
	width= love.graphics.getWidth(), 
	height= love.graphics.getHeight(), 
	border= 10, MAX_ITEM= 1000, effect= false 
} 

function love.keypressed(key ) 
	if key == "escape" then love.event.quit() end 
end 

function love.mousereleased(x, y, btn ) 
	for i= 1, 1000 do 
		-- x, y, Ƕ
		table.insert(env_.items, { env_.width* math.random(), 
				env_.height* math.random(), 
				2* math.pi* math.random(), 
			} ) 
	end 
	env_.MAX_ITEM= env_.MAX_ITEM+ 1000 
end 

local function out_t1() 
	local ret_= "" local tbl= {} 
	--tbl= love.filesystem.getDirectoryItems("" ) 
	tbl[1 ]= love.filesystem.getSaveDirectory() 
	for i, j in pairs(tbl ) do 
		if 'table'== type(j ) then 
			ret_= ret_ .. i .. ' | ' 
		elseif 'number'== type(i ) then 
			ret_= ret_ .. tostring(j ) .. ' | ' 
		end 
	end 
	
	if nil then 
		ffi= require "ffi" ret_= string.rep("\0", 0x0400 ) 
		local k1 local func_= "_getcwd" ffi.cdef(
			"const char *" .. func_ .. "(const char *, int );" ) 
		k1= ffi.C[func_ ](ret_, #ret_ ) 
		ret_= ffi.string(k1 ) 
	end 
	return ret_ 
end 

function love.load() -- love2d ʼ 
	--shader﷨! עʹ"//"ÿβ";""()" 
	local shader1= [[ 
		vec4 effect(vec4 color, Image texture, 
			vec2 texture_coords, vec2 pixel_coords ) { 
			//(r,g,b,a)ɫȡֵ0-1
			//  timeв֤0-1Χ 
			return vec4((1.+ sin(time ) )/ 2., 
				abs(cos(time ) ), abs(sin(time ) ), 1. ); 
		} 
	]] 
	local shader2= [[ 
    vec4 test(number x ) { 
			vec4 color; 
			if( x> -1. && x< -.5 ) 
				color= vec4(.8, .8, .8, 1. ); 
			else if(x> -.5 && x< 0 ) 
				color= vec4(.4, .4, .8, 1. ); 
			else if(x> 0 && x< .5 ) 
				color= vec4(.2, .2, .4, 1. ); 
			else 
				color= vec4(.1, .1, .1, 1. ); 
			return color; 
    } 
		vec4 effect(vec4 color, Image texture, 
			vec2 texture_coords, vec2 pixel_coords ) { 
			return test(cos(time ) ); 
		} 
	]] 
	local shader3= [[ 
		vec4 effect(vec4 colour, Image image, 
			vec2 local, vec2 screen ) 
		{
			//ɫ 
			vec4 screen_colour= vec4(
				screen.x/ (0x0300- time* 0x10 ), 
				screen.y/ 0x0100, .2, 1. ); 
			return screen_colour; 
		} 
	]] 
	local shader4= [[ 
		vec4 effect(vec4 colour, Image image, 
			vec2 local, vec2 screen ) 
		{
			//ɫ 
			vec4 coord_colour= vec4(local.x, local.y, 0, 1. ); 
			//ʹкʵ 
			vec4 image_colour= Texel(image, local ); 
			// ɫ 
			return mix(coord_colour, image_colour, .5 ); 
		} 
	]] 
	--1 shader 
	--extern number time; //ⲿ, ⲿԴֵȡ 
	local code_= "extern number time; " .. shader3 
	env_.effect= love.graphics.newShader(code_ ) 
	
	env_.font14= love.graphics.newFont(
			"SourceHanSansCN-Light.otf", 14 ) 
	env_.font28= love.graphics.newFont(
			"SourceHanSansCN-Light.otf", 28 ) 
	
	env_.polygon= { 0, 0, 23, 25, 25, 21, 18, 37, 5, 23, } 
	function env_.xy(x, y ) 
		love.graphics.push() love.graphics.translate(x, y ) 
	end 
	for i= 1, env_.MAX_ITEM do 
		-- x, y, Ƕ
		table.insert(env_.items, { env_.width* math.random(), 
				env_.height* math.random(), 
				2* math.pi* math.random(), 
			} ) 
	end 
	
	--love.window.setMode(env_.width, env_.height, 
	--	{ fsaa= 1, vsync= false, } ) 
	
	if nil then 
		canvas = love.graphics.newCanvas(env_.width, env_.height ) 
		love.graphics.setCanvas(canvas ) canvas:clear() 
		love.graphics.setBlendMode('alpha' ) 
		love.graphics.setColor(255, 0, 0, 128 ) 
		love.graphics.rectangle('fill', 0, 0, 
			env_.width, env_.height ) 
		love.graphics.setCanvas() 
	end 
	
end 

function love.draw() -- GPU  
	-- 2 رshaderΪĬЧ 
	local w_= env_.width- env_.border* 2 
	local h_= (env_.height- env_.border* 3 )/ 2 
	
	love.graphics.setShader() 
	love.graphics.setColor(255, 255, 255 ) 
	env_.xy(env_.border, env_.border ) 
	love.graphics.rectangle('fill', 0, 0, w_, h_ ) 
	love.graphics.pop() 
	
	-- 2 effect shaderЧѤ 
	if env_.effect then love.graphics.setShader(env_.effect ) end 
	env_.xy(env_.border, h_+ env_.border* 2 ) 
	love.graphics.rectangle('fill', 0, 0, w_, h_ ) 
	love.graphics.pop() 
	
	love.graphics.setShader() local j local strZH_CN_t1= "" 
	for i= 1, env_.MAX_ITEM do 
		env_.xy(env_.items[i ][1 ], env_.items[i ][2 ] ) 
		j= env_.items[i ][3 ] love.graphics.rotate(j ) 
		j= 256* j/ (2* math.pi ) 
		love.graphics.translate(env_.t* 16, 0 ) 
		love.graphics.setColor(j, 256- j, env_.tick ) 
		love.graphics.polygon("fill", env_.polygon ) 
		love.graphics.pop() 
	end 
	
	if canvas then 
		love.graphics.setBlendMode('premultiplied' ) 
		love.graphics.draw(canvas ) 
		love.graphics.setBlendMode('alpha' ) 
	end 
	
	if iconv then strZH_CN_t1= iconv("\n" ) end 
	
	env_.font28:setLineHeight(0.7 ) 
	love.graphics.setFont(env_.font28 ) 
	love.graphics.setColor(255, 0, 0 ) 
	love.graphics.printf(string.format("%06d\n[%s]%s", 
			env_.tick, out_t1(), strZH_CN_t1 ), 
		220, 120, 300, nil, 0, 1 ) -- env_.t, 2 ) --
	--love.graphics.setFont(env_.font28 ) 
	--love.graphics.setColor(0, env_.tick, 0 ) 
	--love.graphics.printf(
		--string.format("%06d%s%s", env_.tick, strZH_CN_t1 ), 
		--220, 180, 200, nil, env_.t, 1 ) 
	
end 
function love.draw_() -- ͨ 
	love.graphics.rectangle('fill', 10, 10, 780, 285 ) 
	love.graphics.setColor((1.+ 
		math.sin(env_.t ) )/ 2.* 255, 
		math.abs(math.cos(env_.t ) )*255., 
		math.abs(math.sin(env_.t ) )*255., 255. ) 
	love.graphics.rectangle('fill', 10, 305, 780, 285 ) 
end 

function love.update(dt ) --3  
	env_.t= env_.t+ dt env_.tick= env_.tick+ 1 
	if env_.effect then env_.effect:send("time", env_.t ) end 

	for i= 1, env_.MAX_ITEM do 
		--env_.items[i ] 
	end 
	
end 
